﻿using ThinkGeo.MapSuite.DesktopEdition;
namespace WindowsFormsApplication2
{
    /// <summary>
    /// This class is used to handle dismissing the trackshape.  It also has a property to determine if you are in a trackshape operation.  The Interactive click interval is changed because the is a discrepency between when the user clicks and the point is registerd when the vlaue is left at the default 500.
    /// </summary>
    public class CustomTrackInteractiveOverlay : TrackInteractiveOverlay
    {
        private bool isTracking = false;
        public CustomTrackInteractiveOverlay():base()
        {
           
        }

        public bool IsTracking
        {
            get { return isTracking; }
           
        }

        public void EndTracking()
        {
            base.EndTracking();
        }
        protected override void OnTrackStarted(TrackStartedTrackInteractiveOverlayEventArgs e)
        {
            InteractiveClickInterval = 400;
            isTracking = true;
            base.OnTrackStarted(e);
        }
        protected override void OnTrackEnded(TrackEndedTrackInteractiveOverlayEventArgs e)
        {
            InteractiveClickInterval = 1;
            isTracking = false;
            base.OnTrackEnded(e);
        }
              
    }
}
