﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using ThinkGeo.MapSuite.Core;
using ThinkGeo.MapSuite.DesktopEdition;

namespace WindowsFormsApplication2
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
            winformsMap1.MapUnit = GeographyUnit.Meter;
            winformsMap1.TrackOverlay = new CustomTrackInteractiveOverlay();
            winformsMap1.TrackOverlay.TrackEnded += new EventHandler<TrackEndedTrackInteractiveOverlayEventArgs>(TrackOverlay_TrackEnded);
            winformsMap1.KeyDown += new KeyEventHandler(winformsMap1_KeyDown);
            winformsMap1.TrackOverlay.TrackMode = TrackMode.Polygon;
            //setting the interactiveclick interval here ensures the first point is set in the proper location.  After the trackshape is started, the value is set to 400 in the customtrackoverlay.
            InteractiveOverlay.InteractiveClickInterval = 1;
        }

        void winformsMap1_KeyDown(object sender, KeyEventArgs e)
        {
            switch (e.KeyCode)
            {
                case Keys.Escape: //cancels the current lasso operation
                    TrackOverlayCancelled();
                    break;
            }
        }

        void TrackOverlay_TrackEnded(object sender, TrackEndedTrackInteractiveOverlayEventArgs e)
        {
            //setting the interactiveclick interval here ensures the first point is set in the proper location.  After the trackshape is started, the value is set to 400 in the customtrackoverlay.
            InteractiveOverlay.InteractiveClickInterval = 1;
        }
        /// <summary>
        /// Cancels the current lasso operation
        /// </summary>
        private void TrackOverlayCancelled()
        {
         ClearTrackingLayer();

            if (winformsMap1.TrackOverlay.TrackMode == TrackMode.Polygon ||
                winformsMap1.TrackOverlay.TrackMode == TrackMode.Line)
            {   //we are using a custom overlay to handle this
               ((CustomTrackInteractiveOverlay)winformsMap1.TrackOverlay).EndTracking();
                winformsMap1.TrackOverlay.MouseDoubleClick(new InteractionArguments());
            }
            else
            {
                winformsMap1.TrackOverlay.MouseUp(new InteractionArguments());
            }

            winformsMap1.Refresh();
        }

        private void ClearTrackingLayer()
        {
            winformsMap1.TrackOverlay.Lock.EnterWriteLock();
            try
            {
                int count = winformsMap1.TrackOverlay.TrackShapeLayer.InternalFeatures.Count;
                if (count > 0)
                {
                    winformsMap1.TrackOverlay.TrackShapeLayer.InternalFeatures.Clear();
                }
            }
            finally
            {
                winformsMap1.TrackOverlay.Lock.ExitWriteLock();
            }
        }

    }
}
